local ASP = Apollo.GetAddon("ActionSetProfiles")

local kstrBaseUrl = "http://ws-base.com/builds/generator/"

local ktAbilityOrder = {
	[GameLib.CodeEnumClass.Warrior] = { 
		{ 18309, 37968, 18359, 36860, 47091, 19778, 30896, 37482, 21806, 18580 }, 
		{ 39339, 35468, 23169, 18360, 23328, 18572, 31155, 18578, 38445, 37245 }, 
		{ 38017, 18569, 18547, 18363, 18585, 35501, 35146, 35526, 16970, 32720 } 
	}, 
	[GameLib.CodeEnumClass.Engineer] = { 
		{ 26468, 25473, 25673, 27002, 20396, 25538, 25739, 20639, 22652, 20763 }, 
		{ 27082, 25472, 25623, 25680, 26059, 25626, 26010, 26775, 20628, 34347 }, 
		{ 25635, 20492, 26762, 27021, 26991, 26998, 25951, 25819, 28614, 34176 } 
	}, 
	[GameLib.CodeEnumClass.Esper] = {
		{ 19102, 19019, 28756, 19163, 19024, 27734, 21613, 19139, 21779, 19136 }, 
		{ 19030, 19031, 19218, 19033, 19207, 19341, 19362, 22282, 19258, 19379 }, 
		{ 19022, 21743, 19025, 19271, 19028, 19273, 19355, 19029, 19190, 21812 }
	}, 
	[GameLib.CodeEnumClass.Medic] = {
		{ 47778, 16322, 47675, 26038, 25666, 26061, 47793, 27080, 25692, 25735 }, 
		{ 47784, 25579, 47807, 25530, 16336, 26120, 25566, 24867, 16757, 26433 }, 
		{ 26543, 25747, 22861, 25617, 26786, 25613, 25729, 26529, 25799, 25595 } 
	}, 
	[GameLib.CodeEnumClass.Stalker] = {
		{ 23148, 23161, 23183, 23221, 23205, 23218, 32336, 23268, 23337, 23984 }, 
		{ 23523, 23500, 23608, 23694, 23955, 31937, 23699, 23892, 31976, 23908 }, 
		{ 23173, 23587, 23704, 26865, 23236, 23281, 23829, 32921, 23705, 23896 } 
	},
	[GameLib.CodeEnumClass.Spellslinger] = {
		{ 27638, 20684, 20718, 20734, 27774, 21056, 30666, 23274, 21650, 27736 }, 
		{ 23012, 23441, 23479, 21490, 23468, 23418, 23463, 23481, 23959, 27504 }, 
		{ 20325, 20323, 37920, 30160, 23255, 23664, 34372, 16454, 20901, 23414 } 
	},
}

local maxbits = 5
--pplCvyvEvnvK
local exportChars = "WvlgUCsA7pGZ3zSjakbP2x0mTB6htH8JuKMq1yrnwEQDLY5IVNXdcioe9fF4OR_-"
local importChars = {}
for i = 1, #exportChars do
    importChars[exportChars:sub(i,i)] = i
end


ASP.export_wsbase = function(tAbilities, tTiers)
  local data = ktAbilityOrder[GameLib.GetPlayerUnit():GetClassId()]
  local state = {{}, {}, {}}
  
  for nStateIdx, tSpells in ipairs(data) do
    for nSpellIdx, nSpellId in ipairs(tSpells) do
      for nAIdx = 1,8 do
        if (tAbilities[nAIdx] or 0) > 0 and nSpellId == tAbilities[nAIdx] then
          state[nStateIdx][nSpellIdx] = tTiers[nAIdx]
        end
      end
    end
  end
  
	local e, t, n, r, i = "", 0,0,-1,-1;
	local s = function() 
    local nChar = bit32.bor(bit32.lshift((i > -1 and 1 or 0), maxbits), t) + 1
		e = e .. (exportChars:sub(nChar, nChar) or "")
		t = 0
		n = 0
		i = -1
	end
	
	local filterMapSome = function(u, r, o)
		local tFilter = {}
		for i = 0,8 do
			if i < u then tFilter[#tFilter + 1] = i end
		end
		
		local tMap = {}
		for i = 1, #tFilter do
			tMap[#tMap + 1] = state[r][o + tFilter[i]] or 0
		end
		
		for i = 1, #tMap do
			if tMap[i] > 0 then
				return true
			end
		end
	end	
	
	local bitlen = function(e, t)
    if (data[e][t] == nil) then return 0 end
    return 5
	end
	local bitfit = function(e, t, n)
		local r = t
		while true do
			local i = bitlen(e, t)
			if i > n or i == 0 then
				return t - r
			end
				
			n = n - i
			t = t + 1
		end
	end
	
	for r = 1, 3 do
    local o = 0
		for ox = 1, #data[r] do
      o = ox
			local u = bitfit(r, o, maxbits - n)
			if (u < 1) then
				s()
				u = bitfit(r, o, maxbits)
			end
			
      
			if i > -1 and not ((state[r][o] or 0) > 0) then
				-- continue
			else
				if n > 0 or filterMapSome(u, r, o) then
					if i > -1 then
						t = o - i
						s()
					end
					local a = bitlen(r, o)
					t = bit32.bxor(bit32.lshift(t, a), (state[r][o] or 0))
					n = n + a
				elseif i < 0 then
					if n > 0 then s() end
          i = o
				end
			end
		end
	
    if i > -1 then
			t = o - (i - 1)
			s()
		elseif n > 0 then
			s()
		end
	end
  return kstrBaseUrl .. GameLib.GetClassName(GameLib.GetPlayerUnit():GetClassId()):lower() .. "#" .. e .. "/"
end

local function array_slice(t, startPos, endPos)
    local tableSize = #t -- Table size
    if endPos == nil then
        -- Only one parameter: extract to end of table
        endPos = tableSize + 1
    end
    if startPos < 0 then
        startPos = tableSize + 1 + startPos
        -- -1 -> last element
        -- -2 -> last two elements, etc.
    end
    if endPos < 0 then
        endPos = tableSize + 1 + endPos
    end
    local result = {}
    for i = startPos, endPos - 1 do
        result[i - startPos + 1] = t[i]
    end
    return result
end

local function string_split(str, sep)
  local sep, fields = sep or ":", {}
  local pattern = string.format("([^%s]+)", sep)
  str:gsub(pattern, function(c) fields[#fields+1] = c end)
  return fields
end

ASP.import_wsbase = function(strUrl)
  if strUrl == nil or strUrl:len() == 0 then return end
  
  local nClassId = GameLib.GetPlayerUnit():GetClassId()
  local strClassName = GameLib.GetClassName(nClassId):lower()
  
  --http://ws-base.com/builds/generator/stalker#lCp1pvvQvMvr/793.794.795.865.946.947.948.836.782.783.784.788.870.871.872.770.771.772.800.881.862.937.774.775
  local wsClassName, strLAS, strAMPs = string.match(strUrl, "ws%-base%.com%/builds%/generator%/([a-z]+)%#([WvlgUCsA7pGZ3zSjakbP2x0mTB6htH8JuKMq1yrnwEQDLY5IVNXdcioe9fF4OR_%-]+)%/?(.*)")
  if wsClassName and wsClassName ~= strClassName then
    return "This build is for " .. tostring(wsClassName) .. " and your class is " .. tostring(strClassName)
  end
  
  if not wsClassName then
    --http://ws-base.com/builds/view/1066-Shaco_PvP_Stalker_1v1_Burst_Build#lCp1pvvQvMvr/793.794.795.865.946.947.948.836.782.783.784.788.870.871.872.770.771.772.800.881.862.937.774.775
    local strBuildName, sl, sa = string.match(strUrl, "ws%-base%.com%/builds%/view%/(.*)%#([WvlgUCsA7pGZ3zSjakbP2x0mTB6htH8JuKMq1yrnwEQDLY5IVNXdcioe9fF4OR_%-]+)%/?(.*)")
    strLAS, strAMPs = sl, sa
  end
  if not strLAS then
    return "This WS-Base.com URL is invalid"
  end
  
  
  local tAbilities, tTiers = {}, {}
  local data = ktAbilityOrder[GameLib.GetPlayerUnit():GetClassId()]
  local state = {{}, {}, {}}
  
  local n, r = 1, 1
  
	local bitlen = function(e, t)
    if (data[e][t] == nil) then return 0 end
    return 5
	end
	local bitfit = function(e, t, n)
		local r = t
		while true do
			local i = bitlen(e, t)
			if i > n or i == 0 then
				return t - r
			end
				
			n = n - i
			t = t + 1
		end
	end
	
  local filterMap = function(o)
		local tFilter = {}
		for i = 0,8 do
			if i < o then tFilter[#tFilter + 1] = i end
		end
		
		local tMap = {}
		for i = 1, #tFilter do
			tMap[#tMap + 1] = bitlen(n, r + tFilter[i])
		end
    return tMap
	end	
  
  local function sumTable(t)
    local nSum = 0
    for _, nVal in ipairs(t) do
      nSum = nSum + nVal
    end
    return nSum
  end
  
  
  for i = 1, #strLAS do
    local s = importChars[strLAS:sub(i, i)]
    if s == nil then 
      return "This WS-Base.com URL is invalid"
    end
    
    if bit32.band(s-1, 32) == 0 then
      local o = bitfit(n, r, maxbits);
      local u = filterMap(o)
      
      for a = 1, #u do
        local f = sumTable(array_slice(u, a + 1))
        local l = bit32.band(bit32.rshift(s-1, f), bit32.lshift(1, u[a])-1)
        state[n][r] = l
        tAbilities[#tAbilities+1] = data[n][r]
        tTiers[#tAbilities] = l
        r = r + 1
      end
    else
      local p = bit32.band(s-1, 31)
      r = r + p
    end
    if r > #data[n] then
      n = n + 1
      r = 1
      if n > #data then break end
    end
  end
--  SendVarToRover("state", state)
--  SendVarToRover("tAbilities", tAbilities)
--  SendVarToRover("tTiers", tTiers)

  return tAbilities, tTiers
end